hpp-core: hpp::core::pathOptimization::TrapezoidalTimeParameterization Class Reference

hpp-core 9.0.2 Implement basic classes for canonical path planning for kinematic chains.

Loading...
Searching...
No Matches
Public Member Functions | Static Public Member Functions | Protected Member Functions | List of all members
hpp::core::pathOptimization::TrapezoidalTimeParameterization Class Reference
Path Optimization

`#include <hpp/core/path-optimization/trapezoidal-time-parameterization.hh>`

Inheritance diagram for hpp::core::pathOptimization::TrapezoidalTimeParameterization:
[legend]
Collaboration diagram for hpp::core::pathOptimization::TrapezoidalTimeParameterization:
[legend]

## Public Member Functions
virtual PathVectorPtr_t | optimize (const PathVectorPtr_t &path)
| Optimize path.
value_type | maxVelocity () const
| Maximum velocity for each output degree of freedom.
void | maxVelocity (const value_type &maxVelocity)
| Set maximum velocity for each output degree of freedom.
value_type | maxAcceleration () const
| Maximum acceleration for each output degree of freedom.
void | maxAcceleration (const value_type &maxAcceleration)
| Set maximum acceleration for each output degree of freedom.
value_type | minimumDuration () const
| Minimum duration assigned to each non-empty subpath.
void | minimumDuration (const value_type &minimumDuration)
| Set minimum duration assigned to each non-empty subpath.
Public Member Functions inherited from hpp::core::PathOptimizer
virtual | ~PathOptimizer ()
ProblemConstPtr_t | problem () const
| Get problem.
void | interrupt ()
| Interrupt path optimization.
void | maxIterations (const unsigned long int &n)
| Set maximal number of iterations.
void | timeOut (const double &timeOut)
| set time out (in seconds)

## Static Public Member Functions
static TrapezoidalTimeParameterizationPtr_t | create (const ProblemConstPtr_t &problem)
| Return shared pointer to new object.

## Protected Member Functions
| TrapezoidalTimeParameterization (const ProblemConstPtr_t &problem)
Protected Member Functions inherited from hpp::core::PathOptimizer
| PathOptimizer (const ProblemConstPtr_t &problem)
PathPtr_t | steer (ConfigurationIn_t q1, ConfigurationIn_t q2) const
void | monitorExecution ()
void | endIteration ()
bool | shouldStop () const
void | initFromParameters ()

## Additional Inherited Members
Protected Attributes inherited from hpp::core::PathOptimizer
bool | interrupt_

## Detailed Description

Add a trapezoidal velocity profile time parameterization to a path.

The optimizer computes one scalar time law per direct subpath. The maximum scalar path velocity and acceleration are chosen so that, using the path velocity bound, no output degree of freedom exceeds the configured scalar limits.

Parameters can be configured with the getter and setter methods:

- maxVelocity
- maxAcceleration
- minimumDuration

## Constructor & Destructor Documentation

## ◆ TrapezoidalTimeParameterization()

hpp::core::pathOptimization::TrapezoidalTimeParameterization::TrapezoidalTimeParameterization | ( | const ProblemConstPtr_t & | problem | ) |
| protected

## Member Function Documentation

## ◆ create()

static TrapezoidalTimeParameterizationPtr_t hpp::core::pathOptimization::TrapezoidalTimeParameterization::create | ( | const ProblemConstPtr_t & | problem | ) |
| static

Return shared pointer to new object.

## ◆ maxAcceleration() [1/2]

value_type hpp::core::pathOptimization::TrapezoidalTimeParameterization::maxAcceleration | ( |  | ) | const
| inline

Maximum acceleration for each output degree of freedom.

## ◆ maxAcceleration() [2/2]

void hpp::core::pathOptimization::TrapezoidalTimeParameterization::maxAcceleration | ( | const value_type & | maxAcceleration | ) |
| inline

Set maximum acceleration for each output degree of freedom.

## ◆ maxVelocity() [1/2]

value_type hpp::core::pathOptimization::TrapezoidalTimeParameterization::maxVelocity | ( |  | ) | const
| inline

Maximum velocity for each output degree of freedom.

## ◆ maxVelocity() [2/2]

void hpp::core::pathOptimization::TrapezoidalTimeParameterization::maxVelocity | ( | const value_type & | maxVelocity | ) |
| inline

Set maximum velocity for each output degree of freedom.

## ◆ minimumDuration() [1/2]

value_type hpp::core::pathOptimization::TrapezoidalTimeParameterization::minimumDuration | ( |  | ) | const
| inline

Minimum duration assigned to each non-empty subpath.

## ◆ minimumDuration() [2/2]

void hpp::core::pathOptimization::TrapezoidalTimeParameterization::minimumDuration | ( | const value_type & | minimumDuration | ) |
| inline

Set minimum duration assigned to each non-empty subpath.

## ◆ optimize()

virtual PathVectorPtr_t hpp::core::pathOptimization::TrapezoidalTimeParameterization::optimize | ( | const PathVectorPtr_t & | path | ) |
| virtual

Optimize path.

Implements hpp::core::PathOptimizer.

The documentation for this class was generated from the following file:

- include/hpp/core/path-optimization/trapezoidal-time-parameterization.hh